#include "LittleFS.h"
#define FORMAT_LittleFS_IF_FAILED false

void listDir(const char * dirname, uint8_t levels) {
  String prettyprint = "";
  int i =0;
  while(i<levels) {
    prettyprint += "  ";
    i++;
  } 
  File root = LittleFS.open(dirname);
  if (!root) {
    Serial.println("- failed to open directory");
    return;
  }
  if (!root.isDirectory()) {
    Serial.println(" - not a directory");
    return;
  }
  File file = root.openNextFile();

  while (file) {
    if (file.isDirectory()) {
      Serial.printf("%s%s/\r\n", prettyprint, file.name());
      listDir(file.path(), levels+1);
    } else {
      Serial.printf("%s%s\tSIZE: %d\r\n", prettyprint, file.name(), file.size());
    }
    file = root.openNextFile();
  }
}

void setup() {
  Serial.begin(115200);
  if (!LittleFS.begin(FORMAT_LittleFS_IF_FAILED)) {
    Serial.println("LittleFS Mount Failed");
    return;
  }
  listDir("/", 0);
}

void loop() {

}
