/*
 *  ESP32
 *  SPIFFS write, read and seek file
 *  by Mischianti Renzo <https://www.mischianti.org>
 *
 *  https://www.mischianti.org/2020/06/04/esp32-integrated-spiffs-filesystem-part-2/
 *
 */
#include "Arduino.h"
#include "SPIFFS.h"
 
void setup() {
    Serial.begin(115200);
    delay(500);
    Serial.println(F("Inizializing FS..."));
    if (SPIFFS.begin()){
        Serial.println(F("done."));
    }else{
        Serial.println(F("fail."));
    }
    // To remove previous test
    // SPIFFS.remove(F("/testCreate.txt"));
    File testFile = SPIFFS.open(F("/testCreate.txt"), "w");
    if (testFile){
        Serial.println("Write file content!");
        testFile.print("*Here is the test text*");
        testFile.close();
    }else{
        Serial.println("Problem on create file!");
    } 
    testFile = SPIFFS.open(F("/testCreate.txt"), "r");
    if (testFile){
        Serial.println("Read file content!");
        /**
         * File derivate from Stream so you can use all Stream method
         * readBytes, findUntil, parseInt, println etc
         */
        Serial.println(testFile.readString());
        testFile.close();
    }else{
        Serial.println("Problem on read file!");
    }
    testFile = SPIFFS.open(F("/testCreate.txt"), "r");
    if (testFile){
        /**
         * mode is SeekSet, position is set to offset bytes from the beginning.
         * mode is SeekCur, current position is moved by offset bytes.
         * mode is SeekEnd, position is set to offset bytes from the end of the file.
         * Returns true if position was set successfully.
         */
        Serial.println("Position inside the file at 9 byte!");
        testFile.seek(9, SeekSet);
        Serial.println("Read file content!");
        Serial.println(testFile.readString());
        testFile.close();
    }else{
        Serial.println("Problem on read file!");
    }
}
 
void loop() {
}
